/*
 *                            COPYRIGHT
 *
 *  osm-rnd - OpenStreetMap editor/viewer
 *  Copyright (C) 2023 Tibor 'Igor2' Palinkas
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 *  Contact:
 *    Project page: http://repo.hu/projects/osm-rnd
 *    lead developer: http://repo.hu/projects/osm-rnd/contact.html
 *    mailing list: (not yet)
 */

#ifndef OSM_EVENT_H
#define OSM_EVENT_H

#include <librnd/core/event.h>

/* Prefix:
   [d]: per-design: generated for a specific rnd_design_t
   [a]: per-app: generated once, not targeted or specific for a rnd_design_t
*/
enum {
	OSM_EVENT_LAYERS_CHANGED = RND_EVENT_app,   /* [d] called after layers or layer groups change (used to be the LayersChanged action) */
	OSM_EVENT_LAYERVIS_CHANGED,                 /* [d] called after the visibility of layers has changed */
	OSM_EVENT_LAYER_SELECTED,                   /* [d] called when a new layer is selected; args: int layer_id */
	OSM_EVENT_STYLE_DETERMINE,                  /* [d] called to determine the style of an object; args: osm_style_t **stlye_id, osm_any_obj_t *obj */
	OSM_EVENT_UNDO_POST,                        /* [d] called after undo */
	OSM_EVENT_LIST_IMAGERY_USED,                /* [d] called at commit to build the imagery_used tag; imagery layers shall append their name; arg: (gds_t *imagery_used, gds_t *offset) */
	OSM_EVENT_SELECTION_CHANGED,                /* [d] called when objects are selected/unselected */
	OSM_EVENT_last                              /* not a real event */
};

void osm_event_init_app(void);

#endif
